#	Generate a vplot file that draws a ray at a boundary
#
#	vpbound.x par=vpbound.p out=vpbound.v 
#
# FILES:
#	INPUT:	
#	OUTPUT:
#		stdout:	vplot file
#		
# PARAMETERS:
#	FROM INPUT:
#	FROM PAR:
#		xll,yll,xur,yur the true coordinates of the vplot
#		plotcol=6 	color of plot
#		plotfat=1	fat of plot
#		wantframe=1	=0 no frame; =1 frame
#				
#
# NOTE:
#% end of self doc
#
#-------------
# keyword:
#-------------

integer narray

from par:	integer narray=11

allocate:	real xx(narray),zz(narray)

subroutine submain(narray,xx,zz)

integer narray,iarray
integer plotcol,plotfat,titlesz,titlefat,fat
integer wantframe
integer outfd, output
real xll,yll,xur,yur
real xmin,zmin,xmax,zmax,xrange,zrange,zxrange
real xcenter,zcenter,xscale,zscale
real xcenter1,zcenter1
real x,z,x1,z1,x2,z2
real theta,theta1,theta2
real xx(narray),zz(narray)
character*50 out
character*50 title
character*73 longstr

# PARAMETERS
#    INPUT 
	from par:	integer plotcol=6,plotfat=1,titlesz=12,titlefat=5
	from par:	integer wantframe=1
	from par:	real xll=1.705,yll=2.165,xur=11.945,yur=8.075
	from par:	character title=" "

#    OUTPUT

# CHECK

# FILES
#   INPUT

#   OUTPUT
	outfd = output()
	if(getch('out','s',out) == 0)
	   call vpfilep(outfd)
	else
	   call vpfile(out)

	call hclose()

# CALCULATION 
	#set parameters
	xmin = xll
	zmin = yll
	xmax = xur
	zmax = yur
	xcenter=0.5*(xmin+xmax)
	zcenter=0.5*(zmin+zmax)
	xrange = xmax-xmin
	zrange = zmax-zmin
	zxrange = sqrt(xrange*xrange+zrange*zrange)

	# set vplot scales
	call vporig(xll,yll)
	call vpuorig(xmin,zmin)
        xscale = (xur-xll)/(xmax-xmin)
        zscale = (yur-yll)/(zmax-zmin)
	call vpscale(xscale,zscale)

	theta1 = 4.*atan(1.)/3.
	theta2 = 2.*atan(1.)/3.
	call vpdash(0.1,0.1,0.1,0.1)
	call vpcolor(6)
	fat = 2.*plotfat
	call vpfat(fat)
	x = xmin+1./3.*xrange
	z = zmin
	call vpumove(x,z)
	x = xmin
	z = zmax
	call vpudraw(x,z)
	x = xmin+2./3.*xrange
	z = zmax
	call vpudraw(x,z)
	x = xmax
	z = zmin
	call vpudraw(x,z)
	x = xmin+1./3.*xrange
	z = zmin
	call vpudraw(x,z)
	call vpcolor(7)
	fat = plotfat
	call vpfat(fat)
	x1 = xmin+2./3.*xrange
	z1 = zmax
	x2 = xmin+2./3.*xrange
	z2 = zmax-0.2*zxrange
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange)
	x1 = xmin+2./3.*xrange
	z1 = zmax
	x2 = xmin+2./3.*xrange+0.2*zxrange
	z2 = zmax
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange)
	x = xmin+0.5*xrange-0.2*zxrange*sin(theta1)
	z = zmin+0.5*zrange+0.2*zxrange*cos(theta1)
	call vpumove(x,z)
	x = xmin+0.5*xrange+0.2*zxrange*sin(theta1)
	z = zmin+0.5*zrange-0.2*zxrange*cos(theta1)
	call vpudraw(x,z)
	call vpdash(0.,0.,0.,0.)
	
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	x = xmin+1./3.*xrange
	z = zmin
	call vpumove(x,z)
	x = xmin+2./3.*xrange
	z = zmax
	call vpudraw(x,z)
	call vpcolor(3)
	x1 = xmin+0.5*xrange-0.2*zxrange*sin(theta2)
	z1 = zmin+0.5*zrange+0.2*zxrange*cos(theta2)
	x2 = xmin+0.5*xrange
	z2 = zmin+0.5*zrange
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange)
	x1 = xmin+0.5*xrange
	z1 = zmin+0.5*zrange
	x2 = xmin+0.5*xrange+0.2*zxrange*sin(theta2)
	z2 = zmin+0.5*zrange-0.2*zxrange*cos(theta2)
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange)

	call vpcolor(7)
	fat = plotfat
	call vpfat(fat)
	x = xmin+0.5*xrange-0.1*zxrange*sin(theta1)
	z = zmin+0.5*zrange+0.1*zxrange*cos(theta1)
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = theta1+iarray*(theta2-theta1)/narray
	   x = xmin+0.5*xrange-0.1*zxrange*sin(theta)
	   z = zmin+0.5*zrange+0.1*zxrange*cos(theta)
	   call vpudraw(x,z)
	}
	x = xmin+0.5*xrange+0.1*zxrange*sin(theta1)
	z = zmin+0.5*zrange-0.1*zxrange*cos(theta1)
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = theta1+iarray*(theta2-theta1)/narray
	   x = xmin+0.5*xrange+0.1*zxrange*sin(theta)
	   z = zmin+0.5*zrange-0.1*zxrange*cos(theta)
	   call vpudraw(x,z)
	}
	x = xmin+2./3.*xrange
	z = zmax-0.1*zxrange
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = iarray*(theta2)/narray
	   x = xmin+2./3.*xrange-0.1*zxrange*sin(theta)
	   z = zmax-0.1*zxrange*cos(theta)
	   call vpudraw(x,z)
	}
	x = xmin+1./3.*xrange
	z = zmin
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.012*zxrange*sin(theta)
	   zz(iarray) = z+0.012*zxrange*cos(theta)
	}
	call vpcolor(0)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
	x = xmin+2./3.*xrange
	z = zmax
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.012*zxrange*sin(theta)
	   zz(iarray) = z+0.012*zxrange*cos(theta)
	}
	call vpcolor(0)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
	x = xmin
	z = zmax
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.012*zxrange*sin(theta)
	   zz(iarray) = z+0.012*zxrange*cos(theta)
	}
	call vpcolor(0)
	call vpufill(xx,zz,narray)
	call vpcolor(6)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
	x = xmax
	z = zmin
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.012*zxrange*sin(theta)
	   zz(iarray) = z+0.012*zxrange*cos(theta)
	}
	call vpcolor(0)
	call vpufill(xx,zz,narray)
	call vpcolor(6)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)

# write title
	call vpcolor(7)
	call vpfat(titlefat)
        call vptjust(2,1)
        x = xcenter
        z = zmax+0.008*titlesz*zxrange
        call vputext(x,z,titlesz,0,title)

	call vpcolor(7)
	call vpfat(2)
	call vptjust(2,3)
	x = xmin+0.5*xrange-0.15*zxrange*sin(0.5*theta2+0.5*theta1)
	z = zmin+0.5*zrange+0.15*zxrange*cos(0.5*theta2+0.5*theta1)
	call vputext(x,z,10,0,'\\F10 q')
	x = xmin+0.5*xrange+0.15*zxrange*sin(0.5*theta2+0.5*theta1)
	z = zmin+0.5*zrange-0.15*zxrange*cos(0.5*theta2+0.5*theta1)
	call vputext(x,z,10,0,'\\F10 q')
	x = xmin+2./3.*xrange-0.15*zxrange*sin(0.25*theta1)
	z = zmax-0.15*zxrange*cos(0.25*theta1)
	call vputext(x,z,10,0,'\\F10 f')
	x = xmin+2./3.*xrange
	z = zmax-0.22*zxrange
	call vputext(x,z,10,0,'z')
	x = xmin+2./3.*xrange+0.22*zxrange
	z = zmax
	call vputext(x,z,10,0,'x')
	call vptfont(-1,-1,2)
	x = xmin+0.2*xrange
	z = zmax-0.08*zrange
 	longstr(1:30)="(v\\^\\s60 -\\s100 \\_\\h\\s60 \\_x\\^"
	longstr(31:56)="\\s100 ,v\\^\\s60 -\\s100 \\_\\h"
	longstr(57:73)="\\s60 \\_z\\^\\s100 )"
	call vputext(x,z,10,0,longstr)
	x = xmax-0.2*xrange
	z = zmin+0.08*zrange
 	longstr(1:30)="(v\\^\\s60 +\\s100 \\_\\h\\s60 \\_x\\^"
	longstr(31:56)="\\s100 ,v\\^\\s60 +\\s100 \\_\\h"
	longstr(57:73)="\\s60 \\_z\\^\\s100 )"
	call vputext(x,z,10,0,longstr)

# draw a frame
	if(wantframe != 0.)
	{
	   call vpcolor(7)
	   call vpfat(1)
	   call vpumove(xmin,zmin)
	   call vpudraw(xmin,zmax)
	   call vpudraw(xmax,zmax)
	   call vpudraw(xmax,zmin)
	   call vpudraw(xmin,zmin)
	}
	   
stop
end
