#	Generate a vplot file that draws rays
#
#	vpraytrc.x par=raytrc.p out=raytrc.v 
#
# FILES:
#	INPUT:	
#	OUTPUT:
#		stdout:	vplot file
#		
# PARAMETERS:
#	FROM INPUT:
#	FROM PAR:
#		xll,yll,xur,yur the true coordinates of the vplot
#		plotcol=6 	color of plot
#		plotfat=1	fat of plot
#		wantframe=1	=0 no frame; =1 frame
#				
#
# NOTE:
#% end of self doc
#
#-------------
# keyword:
#-------------

integer narray

from par:	integer narray=11

allocate:	real xx(narray),zz(narray)

subroutine submain(narray,xx,zz)

integer narray,iarray
integer plotcol,plotfat,titlesz,titlefat,fat
integer wantframe
integer outfd, output
real xll,yll,xur,yur
real xmin,zmin,xmax,zmax,xrange,zrange,zxrange
real xcenter,zcenter,xscale,zscale
real xmin1,zmin1,xmax1,zmax1,xrange1,zrange1,zxrange1
real xcenter1,zcenter1
real z0,x0,x,z,x1,z1,x2,z2
real theta,theta1,theta2,rr
real xx(narray),zz(narray)
character*50 out
character*50 title
character*150 longstr

# PARAMETERS
#    INPUT 
	from par:	integer plotcol=6,plotfat=1,titlesz=12,titlefat=5
	from par:	integer wantframe=1
	from par:	real xll=3.075,yll=1.37,xur=10.575,yur=8.87
	from par:	character title=" "

#    OUTPUT

# CHECK

# FILES
#   INPUT

#   OUTPUT
	outfd = output()
	if(getch('out','s',out) == 0)
	   call vpfilep(outfd)
	else
	   call vpfile(out)

	call hclose()

# CALCULATION 
	#set parameters
	xmin = xll
	zmin = yll
	xmax = xur
	zmax = yur
	xcenter=0.5*(xmin+xmax)
	zcenter=0.5*(zmin+zmax)
	xrange = xmax-xmin
	zrange = zmax-zmin
	zxrange = sqrt(xrange*xrange+zrange*zrange)
	xmin1 = xmin
	zmin1 = zmin+(zmax-zmin)/3
	xmax1 = xmax-(xmax-xmin)/3
	zmax1 = zmax
	xcenter1 = 0.5*(xmin1+xmax1)
	zcenter1 = 0.5*(zmin1+zmax1)
	xrange1 = xmax1-xmin1
	zrange1 = zmax1-zmin1
	zxrange1 = sqrt(xrange1*xrange1+zrange1*zrange1)

	# set vplot scales
	call vporig(xll,yll)
	call vpuorig(xmin,zmin)
        xscale = (xur-xll)/(xmax-xmin)
        zscale = (yur-yll)/(zmax-zmin)
	call vpscale(xscale,zscale)

	x0 = xcenter1+zxrange1*(xmax1-xmin1)/sqrt((xmax1-xmin1)**2+_
	     (zmax1-zmin1)**2)
	z0 = zcenter1+zxrange1*(zmax1-zmin1)/sqrt((xmax1-xmin1)**2+_
	     (zmax1-zmin1)**2)
	rr = sqrt((xmin1-x0)**2+(zmax1-z0)**2)
	theta1 = atan((z0-zmax1)/(x0-xmin1))
	theta2 = atan((z0-zmin1)/(x0-xmax1))
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	x = xmin1
	z = zmax1
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = theta1+iarray*(theta2-theta1)/narray
	   x = xmin1+rr*cos(theta1)-rr*cos(theta)
	   z = zmax1+rr*sin(theta1)-rr*sin(theta)
	   call vpudraw(x,z)
	}
	call vpcolor(7)
	fat = plotfat
	call vpfat(fat)
	x = xmin1+0.1*zxrange1*sin(-0.5*theta1)
	z = zmax1-0.1*zxrange1*cos(0.5*theta1)
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = -0.5*theta1+iarray*(theta1+0.5*theta1)/narray
	   x = xmin1+0.1*zxrange1*sin(theta)
	   z = zmax1-0.1*zxrange1*cos(theta)
	   call vpudraw(x,z)
	}
	x = xmax1+0.1*zxrange1*sin(-0.5*theta1)
	z = zmin1-0.1*zxrange1*cos(0.5*theta1)
	call vpumove(x,z)
	do iarray = 1,narray
	{
	   theta = -0.5*theta1+iarray*(theta2+0.5*theta1)/narray
	   x = xmax1+0.1*zxrange1*sin(theta)
	   z = zmin1-0.1*zxrange1*cos(theta)
	   call vpudraw(x,z)
	}
	call vpcolor(6)
	fat = 2.*plotfat
	call vpfat(fat)
	x1 = xmin1
	z1 = zmax1
	x2 = xmin1+0.22*zxrange1*sin(theta1)
	z2 = zmax1-0.22*zxrange1*cos(theta1)
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange1)
	x1 = xmax1
	z1 = zmin1
	x2 = xmax1+0.2*zxrange1*sin(theta2)
	z2 = zmin1-0.2*zxrange1*cos(theta2)
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange1)
	call vpcolor(6)
	fat = 2.*plotfat
	call vpfat(fat)
	call vpdash(0.1,0.1,0.1,0.1)
	x = xmin1+0.2*zxrange1*sin(0.5*theta1)
	z = zmax1+0.2*zxrange1*cos(0.5*theta1)
	call vpumove(x,z)
	x = xmin1-0.22*zxrange1*sin(0.5*theta1)
	z = zmax1-0.22*zxrange1*cos(0.5*theta1)
	call vpudraw(x,z)
	x = xmax1+0.2*zxrange1*sin(0.5*theta1)
	z = zmin1+0.2*zxrange1*cos(0.5*theta1)
	call vpumove(x,z)
	x = xmax1-0.2*zxrange1*sin(0.5*theta1)
	z = zmin1-0.2*zxrange1*cos(0.5*theta1)
	call vpudraw(x,z)
	x1 = xmax1
	z1 = zmax1
	x2 = xmax1-0.2*zxrange1*sin(0.5*theta1)
	z2 = zmax1-0.2*zxrange1*cos(0.5*theta1)
	call vpuarrow(x1,z1,x2,z2,0.02*zxrange1)
	call vpdash(0.,0.,0.,0.)
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = xmin1+0.008*zxrange1*sin(theta)
	   zz(iarray) = zmax1+0.008*zxrange1*cos(theta)
	}
	call vpcolor(5)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = xmax1+0.008*zxrange1*sin(theta)
	   zz(iarray) = zmin1+0.008*zxrange1*cos(theta)
	}
	call vpcolor(5)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)

# write title
	call vpcolor(7)
	call vpfat(titlefat)
        call vptjust(2,1)
        x = xcenter
        z = zmax+0.008*titlesz*zxrange
        call vputext(x,z,titlesz,0,title)
	write(0,*) x,z,titlesz,title

	call vpcolor(7)
	call vpfat(2)
	call vptjust(2,3)
	x = xmin1+0.15*zxrange1*sin(0.25*theta1)
	z = zmax1-0.15*zxrange1*cos(0.25*theta1)
	call vputext(x,z,10,0,'i\\s60 \\_0\\^')
	x = xmax1+0.15*zxrange1*sin(0.5*theta2-0.25*theta1)
	z = zmin1-0.15*zxrange1*cos(0.5*theta2-0.25*theta1)
	call vputext(x,z,10,0,'i')
	x = xmin1+0.08*zxrange1
	z = zmax1
	call vputext(x,z,10,0,'s\\s60 \\_0\\^')
	x = xmax1+0.08*zxrange1
	z = zmin1+0.02*zxrange1
	call vputext(x,z,10,0,'s')
	x = xmax1-0.25*zxrange1*sin(0.5*theta1)
	z = zmax1-0.25*zxrange1*cos(0.5*theta1)
	longstr = '(v\\s60 \\_x\\^\\s100 ,v\\s60 \\_z\\^\\s100 )'
	call vputext(x,z,10,0,longstr)
	call vptfont(-1,-1,2)
	x = xmin1+0.3*zxrange1*sin(theta1)
	z = zmax1-0.3*zxrange1*cos(theta1)
	longstr = '(u\\s60 \\_0\\^\\s100 ,w\\s60 \\_0\\^\\s100 )'
	call vputext(x,z,10,0,longstr)
	x = xmax1+0.35*zxrange1*sin(theta2)
	z = zmin1-0.35*zxrange1*cos(theta2)
	call vputext(x,z,10,0,'(u,w)')

# draw a frame
	if(wantframe != 0.)
	{
	   call vpcolor(7)
	   call vpfat(1)
	   call vpumove(xmin,zmin)
	   call vpudraw(xmin,zmax)
	   call vpudraw(xmax,zmax)
	   call vpudraw(xmax,zmin)
	   call vpudraw(xmin,zmin)
	}
	   
stop
end
