	subroutine vpwppnt1(nary,rule,za,xa,zb,xb,va,vb,v0,arya,aryb,
     .                      ary0,chk0)
c
c  ------------------------------------------------------------------------
c	Generate vplot file of local paraxial ray with following
c	configuration.
c
c				  
c                         (za,xa)          (zb,xb)
c                          va o             o vb
c                             |             \		
c                             | arya         \ aryb
c
c
c
c				     *(0,0)
c			           v0,ary0,chk0
c						-- (c) Lin Zhang       12/91
c  ------------------------------------------------------------------------
c
c	Name		I/O		Explanation
c
c       nary            I               number of variables
c       rule            I               rule of calculation
c	za,xa,zb,xb	I		coordinates of triangle grid
c	va,vb,v0	I		velocities 
c       arya            I               variables at point a
c       aryb            I               variables at point b
c       ary0            O               variables at origin
c       chk0            O               update check
c
c  ------------------------------------------------------------------------
c
	implicit undefined (a-z)

	integer nary,rule,chk0,directa,directb,direct0
	real za,xa,zb,xb,va,vb,v0,ta,wa,ua,ra,tb,wb,ub,rb
	real tha,thalo,thahi,jja,thb,thblo,thbhi,jjb
	real t0,w0,u0,r0,th0,th0lo,th0hi,jj0
	real vx,vz,vgra,singamma,cosgamma
	real zap,xap,zbp,xbp,wap,uap,wbp,ubp,w0p,u0p,q1a,q1b
	real zoap,xoap,rada,zobp,xobp,radb,zo0p,xo0p,rad0
	real z1ap,x1ap,z1bp,x1bp,w1ap,u1ap,w1bp,u1bp,r1a,r1b
	real t0a,w0a,u0a,r0a,th0a,jj0a,w0ap,u0ap
	real t0b,w0b,u0b,r0b,th0b,jj0b,w0bp,u0bp
	real z3p,x3p,arc2a,arc2b,sig
	real arya(nary),aryb(nary),ary0(nary)

c gradient of velocity
	vz = (xa*(vb-v0)-xb*(va-v0))/(zb*xa-xb*za)
	vx = (zb*(va-v0)-za*(vb-v0))/(zb*xa-xb*za)
	vgra = sqrt(vz*vz+vx*vx)
c initialization
	ta = arya(1)
	wa = arya(2)
	ua = arya(3)
	ra = arya(4)
	tha = arya(5)
	thalo = arya(6)
	thahi = arya(7)
	jja = arya(8)
	tb = aryb(1)
	wb = aryb(2)
	ub = aryb(3)
	rb = aryb(4)
	thb = aryb(5)
	thblo = aryb(6)
	thbhi = aryb(7)
	jjb = aryb(8)
	t0 = 0.
	w0 = 0.
	u0 = 0.
	r0 = 0.
	th0 = 0.
	th0lo = 0.
	th0hi = 0.
	jj0 = 0.

	if(vgra .ne. 0.) then
	   cosgamma = vz/vgra
	   singamma = vx/vgra
	else
	   cosgamma = 1.
	   singamma = 0.
	endif
c find normal distance from point d to two rays
c from point a
	call vpwpq(v0,vgra,cosgamma,singamma,za,xa,wa,ua,zap,xap,
     .              wap,uap,zoap,xoap,rada,z1ap,x1ap,w1ap,u1ap,q1a)
	call wpd(v0,vgra,cosgamma,singamma,zb,xb,zap,xap,wap,uap,
     .           zoap,xoap,rada,directa)
c from point b
	call vpwpq(v0,vgra,cosgamma,singamma,zb,xb,wb,ub,zbp,xbp,
     .              wbp,ubp,zobp,xobp,radb,z1bp,x1bp,w1bp,u1bp,q1b)
	call wpd(v0,vgra,cosgamma,singamma,za,xa,zbp,xbp,wbp,ubp,
     .           zobp,xobp,radb,directb)
	call wppr(v0,vgra,zap,xap,wap,uap,ra,zoap,xoap,rada,
     .            z1ap,x1ap,w1ap,u1ap,r1a)
	call wppr(v0,vgra,zbp,xbp,wbp,ubp,rb,zobp,xobp,radb,
     .            z1bp,x1bp,w1bp,u1bp,r1b)
	call wpsig(v0,vgra,z1ap,x1ap,w1ap,u1ap,z1bp,x1bp,
     .             w1bp,u1bp,sig)
c causality condition
	if((q1a .le. 0. .and. q1b .gt. 0.) .or.
     .     (q1a .lt. 0. .and. q1b .ge. 0.)) then
	   if(directa .lt. 0 .and. directb .gt. 0) then
	      if(sig*r1a .gt. 0. .and. sig*r1b .gt. 0.) then
c use both rays
	         call wppwur1(v0,vgra,cosgamma,singamma,z1ap,x1ap,
     .                        w1ap,u1ap,r1a,q1a,z1bp,x1bp,w1bp,u1bp,
     .                        r1b,q1b,z3p,x3p,w0p,u0p,w0,u0,r0)
	         call wppat1(v0,vgra,zap,xap,wap,uap,z1ap,x1ap,w1ap,u1ap,
     .                       ta,rada,z3p,x3p,r0,q1a,arc2a,t0a)
	         call wppat1(v0,vgra,zbp,xbp,wbp,ubp,z1bp,x1bp,w1bp,u1bp,
     .                       tb,radb,z3p,x3p,r0,q1b,arc2b,t0b)
	         call wppthjj1(v0,vgra,zap,xap,wap,uap,ra,tha,jja,
     .                         z1ap,x1ap,w1ap,u1ap,r1a,z3p,x3p,
     .                         r0,q1a,arc2a,th0a,jj0a)
	         call wppthjj1(v0,vgra,zbp,xbp,wbp,ubp,rb,thb,jjb,
     .                         z1bp,x1bp,w1bp,u1bp,r1b,z3p,x3p,
     .                         r0,q1b,arc2b,th0b,jj0b)
	         call wpavg(arc2a,t0a,arc2b,t0b,t0)
	         call wpavg(arc2a,th0a,arc2b,th0b,th0)
	         call wpavg(arc2a,jj0a,arc2b,jj0b,jj0)
	         th0lo = tha
	         th0hi = thb
	      else
c use either ray
	         call wppwur2(v0,vgra,cosgamma,singamma,z1ap,x1ap,
     .                        w1ap,u1ap,r1a,w0ap,u0ap,w0a,u0a,r0a)
	         call wppat2(v0,vgra,zap,xap,wap,uap,z1ap,x1ap,w1ap,u1ap,
     .                       ta,rada,r0a,q1a,arc2a,t0a)
	         call wppthjj2(v0,vgra,zap,xap,wap,uap,ra,tha,jja,
     .                         z1ap,x1ap,w1ap,u1ap,r1a,r0a,q1a,
     .                         arc2a,th0a,jj0a)
	         call wppwur2(v0,vgra,cosgamma,singamma,z1bp,x1bp,
     .                        w1bp,u1bp,r1b,w0bp,u0bp,w0b,u0b,r0b)
	         call wppat2(v0,vgra,zbp,xbp,wbp,ubp,z1bp,x1bp,w1bp,u1bp,
     .                       tb,radb,r0b,q1b,arc2b,t0b)
	         call wppthjj2(v0,vgra,zbp,xbp,wbp,ubp,rb,thb,jjb,
     .                         z1bp,x1bp,w1bp,u1bp,r1b,r0b,q1b,
     .                         arc2b,th0b,jj0b)
c	         if(th0a .le. thahi .and. th0b .lt. thblo) then
c	            t0 = t0a
c	            w0 = w0a
c	            u0 = u0a
c	            r0 = r0a
c	            th0 = th0a
c	            th0lo = thalo
c	            th0hi = thahi
c	            jj0 = jj0a
c	         else if(th0a .gt. thahi .and. th0b .ge. thblo) then
c	            t0 = t0b
c	            w0 = w0b
c	            u0 = u0b
c	            r0 = r0b
c	            th0 = th0b
c	            th0lo = thblo
c	            th0hi = thbhi
c	            jj0 = jj0b
c	         else
	            if((rule .eq. 0 .and. t0a .le. t0b) .or.
     .                 (rule .eq. 1 .and. abs(jj0a) .le. abs(jj0b)) .or.
     .                 (rule .eq. 2 .and. w0b*u0a .ge. u0b*w0a) .or.
     .                 (rule .eq. 3 .and. w0b*u0a .le. u0b*w0a) .or.
     .                 (rule .eq. 4 .and. w0a .ge. w0b) .or.
     .                 (rule .eq. 5 .and. w0a .le. w0b) .or.
     .                 (rule .eq. 6 .and. t0a .le. t0b)) then
	               t0 = t0a
	               w0 = w0a
	               u0 = u0a
	               r0 = r0a
	               th0 = th0a
	               th0lo = thalo
	               th0hi = thahi
	               jj0 = jj0a
	            else
	               t0 = t0b
	               w0 = w0b
	               u0 = u0b
	               r0 = r0b
	               th0 = th0b
	               th0lo = thblo
	               th0hi = thbhi
	               jj0 = jj0b
	            endif
c	         endif
	      endif
	   else if(directa .lt. 0 .and. directb .lt. 0) then
c use ray a only
	      call wppwur2(v0,vgra,cosgamma,singamma,z1ap,x1ap,
     .                     w1ap,u1ap,r1a,w0p,u0p,w0,u0,r0)
	      call wppat2(v0,vgra,zap,xap,wap,uap,z1ap,x1ap,w1ap,u1ap,
     .                    ta,rada,r0,q1a,arc2a,t0)
	      call wppthjj2(v0,vgra,zap,xap,wap,uap,ra,tha,jja,
     .                      z1ap,x1ap,w1ap,u1ap,r1a,r0,q1a,
     .                      arc2a,th0,jj0)
	      th0lo = thalo
	      th0hi = thahi
	   else if(directa .gt. 0 .and. directb .gt. 0) then
c use ray b only
	      call wppwur2(v0,vgra,cosgamma,singamma,z1bp,x1bp,
     .                     w1bp,u1bp,r1b,w0p,u0p,w0,u0,r0)
	      call wppat2(v0,vgra,zbp,xbp,wbp,ubp,z1bp,x1bp,w1bp,u1bp,
     .                    tb,radb,r0,q1b,arc2b,t0)
	      call wppthjj2(v0,vgra,zbp,xbp,wbp,ubp,rb,thb,jjb,
     .                      z1bp,x1bp,w1bp,u1bp,r1b,r0,q1b,
     .                      arc2b,th0,jj0)
	      th0lo = thblo
	      th0hi = thbhi
	   endif
	else if(q1a .le. 0. .and. q1b .lt. 0.) then
	   if(directa .lt. 0 .and. sig*r1a .le. 0.) then
c use ray a only
	      call wppwur2(v0,vgra,cosgamma,singamma,z1ap,x1ap,w1ap,u1ap,
     .                     r1a,w0ap,u0ap,w0a,u0a,r0a)
	      call wprad(v0,vgra,0.,0.,w0ap,u0ap,zo0p,xo0p,rad0)
	      call wpd(v0,vgra,cosgamma,singamma,zb,xb,0.,0.,w0ap,u0ap,
     .                 zo0p,xo0p,rad0,direct0)
	      if(direct0 .gt. 0) then
	         return
	      endif
	      call wppat2(v0,vgra,zap,xap,wap,uap,z1ap,x1ap,w1ap,u1ap,
     .                    ta,rada,r0a,q1a,arc2a,t0a)
	      call wppthjj2(v0,vgra,zap,xap,wap,uap,ra,tha,jja,z1ap,x1ap,
     .                      w1ap,u1ap,r1a,r0a,q1a,arc2a,th0a,jj0a)
c	      if(th0a .le. thahi) then
	      if(rule .ne. 6) then
	          t0 = t0a
	          w0 = w0a
	          u0 = u0a
	          r0 = r0a
	          th0 = th0a
	          th0lo = thalo
	          th0hi = thahi
	          jj0 = jj0a
	      endif
c	      endif
	   endif
	else if(q1a .gt. 0. .and. q1b .ge. 0.) then
	   if(directb .gt. 0 .and. sig*r1b .le. 0.) then
c use ray b only
	      call wppwur2(v0,vgra,cosgamma,singamma,z1bp,x1bp,w1bp,u1bp,
     .                     r1b,w0bp,u0bp,w0b,u0b,r0b)
	      call wprad(v0,vgra,0.,0.,w0bp,u0bp,zo0p,xo0p,rad0)
	      call wpd(v0,vgra,cosgamma,singamma,za,xa,0.,0.,w0bp,u0bp,
     .                 zo0p,xo0p,rad0,direct0)
	      if(direct0 .lt. 0) then
	         return
	      endif
	      call wppat2(v0,vgra,zbp,xbp,wbp,ubp,z1bp,x1bp,w1bp,u1bp,
     .                    tb,radb,r0b,q1b,arc2b,t0b)
	      call wppthjj2(v0,vgra,zbp,xbp,wbp,ubp,rb,thb,jjb,z1bp,x1bp,
     .                      w1bp,u1bp,r1b,r0b,q1b,arc2b,th0b,jj0b)
c	      if(th0b .ge. thblo) then
	      if(rule .ne. 6) then
	         t0 = t0b
	         w0 = w0b
	         u0 = u0b
	         r0 = r0b
	         th0 = th0b
	         th0lo = thblo
	         th0hi = thbhi
	         jj0 = jj0b
	      endif
c	      endif
	   endif
	endif

	if(t0 .ne. 0. .and. ary0(1) .ne. 0.) then
	   if((rule .eq. 0 .and. t0 .lt. ary0(1)) .or.
     .        (rule .eq. 1 .and. abs(jj0) .le. abs(ary0(8))) .or.
     .        (rule .eq. 2 .and. ary0(2)*u0 .ge. ary0(3)*w0) .or.
     .        (rule .eq. 3 .and. ary0(2)*u0 .le. ary0(3)*w0) .or.
     .        (rule .eq. 4 .and. w0 .ge. ary0(2)) .or.
     .        (rule .eq. 5 .and. w0 .le. ary0(2)) .or.
     .        (rule .eq. 6 .and. abs(jj0) .le. abs(ary0(8)))) then
	      ary0(1) = t0
	      ary0(2) = w0
	      ary0(3) = u0
	      ary0(4) = r0
	      ary0(5) = th0
	      ary0(6) = th0lo
	      ary0(7) = th0hi
	      ary0(8) = jj0
	      chk0 = 1
	      call vpwpwur(v0,cosgamma,singamma,z1ap,x1ap,z1bp,x1bp,
     .                     w0,u0,r0)
	   endif
	else if(t0 .ne. 0. .and. ary0(1) .eq. 0.) then
	   ary0(1) = t0
	   ary0(2) = w0
	   ary0(3) = u0
	   ary0(4) = r0
	   ary0(5) = th0
	   ary0(6) = th0lo
	   ary0(7) = th0hi
	   ary0(8) = jj0
	   chk0 = 1
	   call vpwpwur(v0,cosgamma,singamma,z1ap,x1ap,z1bp,x1bp,
     .                  w0,u0,r0)
	endif

	return
	end

