	subroutine vpwppnt2(nary,rule,side,za,xa,zb,xb,va,vb,v0,aryb,
     .                      ary0,chk0)
c
c  ------------------------------------------------------------------------
c	Generate vplot file of local ray with following
c	configuration.
c
c     	                        (xb,zb)        
c                              vb o               			
c                                  \
c                                   \          		
c	             	           aryb
c
c	                 va o------        *(0,0)
c		           (xa,za)        v0,ary0,chk0
c						-- (c) Lin Zhang       12/91
c  ------------------------------------------------------------------------
c
c	Name		I/O		Explanation
c
c	nary		I		number of variables
c	rule		I		rule of calculation
c	side		I		side of extrapolation
c	za,xa,zb,xb	I		coordinates of triangle grid
c	va,vb,v0	I		velocities 
c	aryb		I		variables at point b
c	ary0		O		variables at origin
c	chk0		O		update check
c
c  ------------------------------------------------------------------------
c
	implicit undefined (a-z)

	integer nary,rule,chk0,directb
	real side
	real za,xa,zb,xb,va,vb,v0
	real tb,wb,ub,rb,thb,thblo,thbhi,jjb
	real t0,w0,u0,r0,th0,th0lo,th0hi,jj0
	real vx,vz,vgra,singamma,cosgamma,vgramin
	real zbp,xbp,wbp,ubp,w0p,u0p,q1b
	real zobp,xobp,radb
	real z1bp,x1bp,w1bp,u1bp,r1b
	real arc2b
	real aryb(nary),ary0(nary)

c parameter limits
	vgramin = 1.e-4*v0
c gradient of velocity
	vz = (xa*(vb-v0)-xb*(va-v0))/(zb*xa-xb*za)
	vx = (zb*(va-v0)-za*(vb-v0))/(zb*xa-xb*za)
	vgra = sqrt(vz*vz+vx*vx)
c initialization
	tb = aryb(1)
	wb = aryb(2)
	ub = aryb(3)
	rb = aryb(4)
	thb = aryb(5)
	thblo = aryb(6)
	thbhi = aryb(7)
	jjb = aryb(8)
	t0 = 0.
	w0 = 0.
	u0 = 0.
	r0 = 0.
	th0 = 0.
	th0lo = 0.
	th0hi = 0.
	jj0 = 0.

	if(vgra .ne. 0.) then
	   cosgamma = vz/vgra
	   singamma = vx/vgra
	else
	   cosgamma = 1.
	   singamma = 0.
	endif
c from point b
	call vpwpq(v0,vgra,cosgamma,singamma,zb,xb,wb,ub,zbp,xbp,
     .             wbp,ubp,zobp,xobp,radb,z1bp,x1bp,w1bp,u1bp,q1b)
	call wpd(v0,vgra,cosgamma,singamma,za,xa,zbp,xbp,wbp,ubp,
     .           zobp,xobp,radb,directb)
	if(side*directb .lt. 0) then
	   return
	endif
c causality condition
	if(side*q1b .gt. 0.) then
c use ray b only
c determine the direction of the ray and cur. at point d
	   call wppr(v0,vgra,zbp,xbp,wbp,ubp,rb,zobp,xobp,radb,
     .               z1bp,x1bp,w1bp,u1bp,r1b)
	   call wppwur2(v0,vgra,cosgamma,singamma,z1bp,x1bp,w1bp,u1bp,
     .                  r1b,w0p,u0p,w0,u0,r0)
c determine the traveltime at point d
	   call wppat2(v0,vgra,zbp,xbp,wbp,ubp,z1bp,x1bp,w1bp,u1bp,
     .                 tb,radb,r0,q1b,arc2b,t0)
	   call wppthjj2(v0,vgra,zbp,xbp,wbp,ubp,rb,thb,jjb,z1bp,x1bp,
     .                   w1bp,u1bp,r1b,r0,q1b,arc2b,th0,jj0)
	   th0lo = thblo
	   th0hi = thbhi
	endif

	if(t0 .ne. 0. .and. ary0(1) .ne. 0.) then
	   if((rule .eq. 0 .and. t0 .lt. ary0(1)) .or.
     .        (rule .eq. 1 .and. abs(jj0) .le. abs(ary0(8))) .or.
     .        (rule .eq. 2 .and. ary0(2)*u0 .ge. ary0(3)*w0) .or.
     .        (rule .eq. 3 .and. ary0(2)*u0 .le. ary0(3)*w0) .or.
     .        (rule .eq. 4 .and. w0 .ge. ary0(2)) .or.
     .        (rule .eq. 5 .and. w0 .le. ary0(2)) .or.
     .        (rule .eq. 6 .and. abs(jj0) .le. abs(ary0(8)))) then
	      ary0(1) = t0
	      ary0(2) = w0
	      ary0(3) = u0
	      ary0(4) = r0
	      ary0(5) = th0
	      ary0(6) = th0lo
	      ary0(7) = th0hi
	      ary0(8) = jj0
	      chk0 = 1
	      call vpwpwur(v0,cosgamma,singamma,z1bp,x1bp,z1bp,x1bp,
     .                     w0,u0,r0)
	   endif
	else if(t0 .ne. 0. .and. ary0(1) .eq. 0.) then
	   ary0(1) = t0
	   ary0(2) = w0
	   ary0(3) = u0
	   ary0(4) = r0
	   ary0(5) = th0
	   ary0(6) = th0lo
	   ary0(7) = th0hi
	   ary0(8) = jj0
	   chk0 = 1
	   call vpwpwur(v0,cosgamma,singamma,z1bp,x1bp,z1bp,x1bp,
     .                  w0,u0,r0)
	endif
	   
	return
	end
