	subroutine vpwppnt3(nary,rule,za,xa,zb,xb,zc,xc,va,vb,vc,v0,
     .                      aryb,ary0,chk0)
c
c  ------------------------------------------------------------------------
c	Generate vplot file of local ray with following
c	configuration.
c
c     	                  (zb,xb)         (zc,xc)
c                         vb o              o vc     			
c                             \              		
c                              \ aryb
c	             			
c	            va o              *(0,0)
c		     (za,xa)        v0,ary0,chk0
c						-- (c) Lin Zhang       12/91
c  ------------------------------------------------------------------------
c
c	Name		I/O		Explanation
c
c	nary		I		number of variables
c	rule		I		rule of calculation
c	za,xa,zb,xb	I		coordinates of triangle grid
c	zc,xc
c	va,vb,vc,v0	I		velocities 
c	aryb		I		variables at point b
c	ary0		I		variables at origin
c	chk0		O		update check
c
c  ------------------------------------------------------------------------
c
	implicit undefined (a-z)

	integer nary,rule,chk0,directm,directn
	real za,xa,zb,xb,zc,xc,va,vb,vc,v0
	real tb,wb,ub,rb,thb,thblo,thbhi,jjb
	real t0,w0,u0,r0,th0,th0lo,th0hi,jj0
	real vxm,vzm,vxn,vzn,vgram,vgran,vgramin
	real cosgammam,singammam,cosgamman,singamman
	real zbmp,xbmp,zbnp,xbnp,wbmp,ubmp,wbnp,ubnp,w0p,u0p
	real zomp,xomp,zonp,xonp,radm,radn,q1m,q1n
	real z1mp,x1mp,z1np,x1np,w1mp,u1mp,w1np,u1np
	real aryb(nary),ary0(nary)

c parameter limits
	vgramin = 1.e-4*v0
c gradient of velocity
	vzm = (xa*(vb-v0)-xb*(va-v0))/(zb*xa-xb*za)
	vxm = (zb*(va-v0)-za*(vb-v0))/(zb*xa-xb*za)
	vzn = (xb*(vc-v0)-xc*(vb-v0))/(zc*xb-xc*zb)
	vxn = (zc*(vb-v0)-zb*(vc-v0))/(zc*xb-xc*zb)
	vgram = sqrt(vzm*vzm+vxm*vxm)
	vgran = sqrt(vzn*vzn+vxn*vxn)
c initialization
	tb = aryb(1)
	wb = aryb(2)
	ub = aryb(3)
	rb = aryb(4)
	thb = aryb(5)
	thblo = aryb(6)
	thbhi = aryb(7)
	jjb = aryb(8)
	t0 = 0.
	w0 = 0.
	u0 = 0.
	r0 = 0.
	th0 = 0.
	th0lo = 0.
	th0hi = 0.
	jj0 = 0.

c to left ray
	if(vgram .ne. 0.) then
	   cosgammam = vzm/vgram
	   singammam = vxm/vgram
	else
	   cosgammam = 1.
	   singammam = 0.
	endif
	call vpwpq(v0,vgram,cosgammam,singammam,zb,xb,wb,ub,
     .             zbmp,xbmp,wbmp,ubmp,zomp,xomp,radm,z1mp,x1mp,
     .             w1mp,u1mp,q1m)
	call wpd(v0,vgram,cosgammam,singammam,za,xa,zbmp,xbmp,
     .           wbmp,ubmp,zomp,xomp,radm,directm)
	if(directm .lt. 0) then
	   return
	endif
c to right ray
	if(vgran .ne. 0.) then
	   cosgamman = vzn/vgran
	   singamman = vxn/vgran
	else
	   cosgamman = 1.
	   singamman = 0.
	endif
	call vpwpq(v0,vgran,cosgamman,singamman,zb,xb,wb,ub,
     .             zbnp,xbnp,wbnp,ubnp,zonp,xonp,radn,z1np,x1np,
     .             w1np,u1np,q1n)
	call wpd(v0,vgran,cosgamman,singamman,zc,xc,zbnp,xbnp,
     .           wbnp,ubnp,zonp,xonp,radn,directn)
	if(directn .gt. 0) then
	   return
	endif
c causality condition
	if((q1m .le. 0. .and. q1n .gt. 0.) .or.
     .     (q1m .lt. 0. .and. q1n .ge. 0.)) then
	   if(radm .lt. 0. .and. radn .le. 0.) then
	      call wppwurt1(v0,vgran,cosgamman,singamman,zbnp,xbnp,
     .                      tb,rb,w0p,u0p,w0,u0,r0,t0)
	   else if(radm .ge. 0. .and. radn .gt. 0.) then
	      call wppwurt1(v0,vgram,cosgammam,singammam,zbmp,xbmp,
     .                      tb,rb,w0p,u0p,w0,u0,r0,t0)
	   else
	      call wppwurt2(vb,v0,zb,xb,tb,rb,w0,u0,r0,t0)
	   endif
	   call wppthjj(vb,v0,rb,thb,jjb,r0,th0,jj0)
	   th0lo = thblo
	   th0hi = thbhi
	endif

	if(t0 .ne. 0. .and. ary0(1) .ne. 0.) then
	   if((rule .eq. 0 .and. t0 .lt. ary0(1)) .or.
     .        (rule .eq. 1 .and. abs(jj0) .le. abs(ary0(8))) .or.
     .        (rule .eq. 2 .and. ary0(2)*u0 .ge. ary0(3)*w0) .or.
     .        (rule .eq. 3 .and. ary0(2)*u0 .le. ary0(3)*w0) .or.
     .        (rule .eq. 4 .and. w0 .ge. ary0(2)) .or.
     .        (rule .eq. 5 .and. w0 .le. ary0(2)) .or.
     .        (rule .eq. 6 .and. abs(jj0) .le. abs(ary0(8)))) then
	      ary0(1) = t0
	      ary0(2) = w0
	      ary0(3) = u0
	      ary0(4) = r0
	      ary0(5) = th0
	      ary0(6) = th0lo
	      ary0(7) = th0hi
	      ary0(8) = jj0
	      chk0 = 1
	      call vpwpwur(v0,cosgammam,singammam,z1mp,x1mp,0.,0.,
     .                     w0,u0,r0)
	      call vpwpwur(v0,cosgamman,singamman,0.,0.,z1np,x1np,
     .                     w0,u0,r0)
	   endif
	else if(t0 .ne. 0. .and. ary0(1) .eq. 0.) then
	   ary0(1) = t0
	   ary0(2) = w0
	   ary0(3) = u0
	   ary0(4) = r0
	   ary0(5) = th0
	   ary0(6) = th0lo
	   ary0(7) = th0hi
	   ary0(8) = jj0
	   chk0 = 1
	   call vpwpwur(v0,cosgammam,singammam,z1mp,x1mp,0.,0.,
     .                  w0,u0,r0)
	   call vpwpwur(v0,cosgamman,singamman,0.,0.,z1np,x1np,
     .                  w0,u0,r0)
	endif

	return
	end
