	subroutine vpwpq(v0,vgra,cosgamma,singamma,z,x,w,u,zp,xp,
     .                   wp,up,zop,xop,rad,z1p,x1p,w1p,u1p,q1)
c
c  ------------------------------------------------------------------------
c	Find the normal distance from the origin to a ray when velocity
c	gradient is constant and draw a vplot.
c
c						-- (c) Lin Zhang       4/92
c  ------------------------------------------------------------------------
c
c	Name		I/O		Explanation
c
c	v0,vgra		I		velocity and its gradient
c	cosgamma	I		rotation parameter
c	singamma	I		rotation parameter
c	z,x,w,u		I		ray parameters at initial point
c	zp,xp,wp,up	O		ray parameters after rotation
c	zop,xop,rad	O		center and radius of cir. ray
c	z1p,x1p,w1p,u1p O		ray parameters at normal point
c	q1		O		normal distance
c
c  ------------------------------------------------------------------------
c
	implicit undefined (a-z)

	real v0,vgra,cosgamma,singamma,z,x,w,u
	real zp,xp,wp,up,zop,xop,rad,z1p,x1p,w1p,u1p,q1
	real wvp,uvp,radmax,num1,num2,den
	real v,v1,sini1,cosi1
c vplot start
	integer npoint,ipoint
	real x1,z1,xt,zt,xtp,ztp,xzsize
	real theta1,theta2,theta

	npoint = 128
	xzsize = 1.
c vplot end

c parameter limits
	radmax = 1.e4

	zp = z*cosgamma+x*singamma
	xp = -z*singamma+x*cosgamma
	wp = w*cosgamma+u*singamma
	up = -w*singamma+u*cosgamma
	v = v0+vgra*zp 
	wvp = wp*v
	uvp = up*v
	if(abs(up)*vgra*radmax .le. 1.) then
c use straight ray
	   rad = 0.
	   zop = 0.
	   xop = 0.
	   q1 = wvp*xp-uvp*zp
	   z1p = -q1*uvp
	   x1p = q1*wvp
	   v1 = v0+vgra*z1p
	   w1p = wvp/v1
	   u1p = uvp/v1
c vplot start
	   call vpcolor(3)
	   call vpfat(2)
	   call vpumove(x,z)
	   x1 = x1p*cosgamma+z1p*singamma
	   z1 = -x1p*singamma+z1p*cosgamma
	   call vpudraw(x1,z1)
	   call vpcolor(5)
	   call vpdash(0.1,0.1,0.1,0.1)
	   call vpudraw(0.,0.)
	   call vpdash(0.,0.,0.,0.)
	   xt = x+0.12*xzsize*u*(v0+vgra*zp)
	   zt = z+0.12*xzsize*w*(v0+vgra*zp)
	   call vpcolor(5)
	   call vpfat(6)
	   call vpuarrow(x,z,xt,zt,0.03*xzsize)
	   xtp = x1p+0.12*xzsize*u1p*v1
	   ztp = z1p+0.12*xzsize*w1p*v1
	   xt = xtp*cosgamma+ztp*singamma
	   zt = -xtp*singamma+ztp*cosgamma
	   call vpuarrow(x1,z1,xt,zt,0.03*xzsize)
c vplot end
	else
c use circular ray
	   rad = 1./(vgra*up)
	   num1 = uvp-up*vgra*zp
	   num2 = wvp+up*vgra*xp
	   zop = -num1*rad
	   xop = num2*rad
	   den = sqrt(num1*num1+num2*num2)
	   cosi1 = num2/den
	   sini1 = num1/den
	   q1 = 2.*(wvp*xp-uvp*zp)+up*vgra*(zp*zp+xp*xp)
	   q1 = q1/(1.+den)
	   z1p = -sini1*q1
	   x1p = cosi1*q1
	   v1 = v0+vgra*z1p
	   w1p = cosi1/v1
	   u1p = sini1/v1
c vplot start
	   call vpcolor(3)
	   call vpfat(2)
	   theta1 = atan2(xp-xop,zp-zop)
	   theta2 = atan2(x1p-xop,z1p-zop)
	   call vpumove(x,z)
	   do ipoint = 1,npoint
	      theta = theta1+ipoint*(theta2-theta1)/npoint
	      ztp = zop+abs(rad)*cos(theta)
	      xtp = xop+abs(rad)*sin(theta)
	      xt = xtp*cosgamma+ztp*singamma
	      zt = -xtp*singamma+ztp*cosgamma
	      call vpudraw(xt,zt)
	   enddo
	   call vpcolor(5)
	   call vpdash(0.1,0.1,0.1,0.1)
	   call vpudraw(0.,0.)
	   call vpdash(0.,0.,0.,0.)
	   xt = x+0.12*xzsize*u*(v0+vgra*zp)
	   zt = z+0.12*xzsize*w*(v0+vgra*zp)
	   call vpcolor(5)
	   call vpfat(6)
	   call vpuarrow(x,z,xt,zt,0.03*xzsize)
	   x1 = x1p*cosgamma+z1p*singamma
	   z1 = -x1p*singamma+z1p*cosgamma
	   xtp = x1p+0.12*xzsize*sini1
	   ztp = z1p+0.12*xzsize*cosi1
	   xt = xtp*cosgamma+ztp*singamma
	   zt = -xtp*singamma+ztp*cosgamma
	   call vpcolor(5)
	   call vpfat(6)
	   call vpuarrow(x1,z1,xt,zt,0.03*xzsize)
c vplot end
	endif

	return
	end
