#
# 	Program generates a vplot file that draws the figure illustrating
#	continuous wavefront type
#
#	vpwptype par=parfile out=file.v > file.V
#
# FILES:
#	INPUT:	
#	OUTPUT:
#		stdout:	vplot file
#		
# PARAMETERS:
#	FROM INPUT:
#	FROM PAR:
#		xll,yll,xur,yur the true coordinates of the vplot
#		plotcol=6 	color of plot
#		plotfat=1	fat of plot
#		wantframe=1	=0 no frame; =1 frame
#				
#
# NOTE:
#% end of self doc
#
#-------------
# keyword:
#-------------

integer narray

from par:	integer narray=11

nary = 8

allocate:	real xx(narray),zz(narray)
allocate:	real arya(nary),aryb(nary),aryc(nary),ary0(nary)

subroutine submain(narray,nary,xx,zz,arya,aryb,aryc,ary0)

integer narray,iarray,nary,iary,chk0
integer plotcol,plotfat,titlesz,titlefat,fat
integer wantframe,outtype
integer outfd, output
real xll,yll,xur,yur
real xmin,zmin,xmax,zmax,xrange,zrange,zxrange
real xcenter,zcenter,xscale,zscale
real vs,vx,vz,v0,x0,z0,dx,dz
real xa,za,xb,zb,xc,zc,xs,zs,rr
real va,vb,vc,vs
real x1a,z1a,x1b,z1b,x,z,x1,z1,x2,z2,theta,theta1,theta2,dscale
real arya(nary),aryb(nary),aryc(nary),ary0(nary)
real xx(narray),zz(narray)
character*50 out
character*50 title
character*73 longstr

# PARAMETERS
#    INPUT 
	from par:	integer plotcol=6,plotfat=1,titlesz=12,titlefat=5
	from par:	integer wantframe=1,outtype=0
	from par:	real xll=2.495,yll=1.37,xur=11.155,yur=8.87
	from par:	character title=" "
	from par:	real dx=0.01,dz=0.00866
	from par:	real vs=1.,vx=0.,vz=0.
	from par:	real x0=1.,z0=1.
	from par:	real v0=vs+vx*x0+vz*z0

# switch two figures
	if(outtype == 0)
	   outtype = 1
	else
	   outtype = 0

#   OUTPUT
	to history:		real xll,yll,xur,yur

# FILES

#   INPUT
#	no input

#   OUTPUT
	outfd = output()
	if(getch('out','s',out) == 0)
	   call vpfilep(outfd)
	else
	   call vpfile(out)

# CHECK
# 	no check

	call vperase()
	call hclose()

# STARTING PROGRAM
	#set parameters
	xmin = -dx
	zmin = -dz
	xmax = dx
	zmax = dz
	xcenter=0.5*(xmin+xmax)
	zcenter=0.5*(zmin+zmax)
	xrange = xmax-xmin
	zrange = zmax-zmin
	zxrange = sqrt(xrange*xrange+zrange*zrange)

	# set vplot scales
	x = 0.5*(xll+xur)
	z = 0.5*(yll+yur)
	call vporig(x,z)
	call vpuorig(0.,0.)
        xscale = (xur-xll)/(xmax-xmin)
        zscale = -(yur-yll)/(zmax-zmin)
	call vpscale(xscale,zscale)

# initializtion
	xa = -dx
	za = 0.
	xb = -0.5*dx
	zb = -dz
	xc = 0.5*dx
	zc = -dz

# draw triangle grid
	call vpdash(0.1,0.2,0.1,0.2)
	call vpcolor(7)
	fat = 2.*plotfat
	call vpfat(fat)
	x = -dx
	z = 0.
	call vpumove(x,z)
	x = dx
	z = 0.
	call vpudraw(x,z)
	x = -0.5*dx
	z = dz
	call vpumove(x,z)
	x = 0.5*dx
	z = -dz
	call vpudraw(x,z)
	x = -0.5*dx
	z = -dz
	call vpumove(x,z)
	x = 0.5*dx
	z = dz
	call vpudraw(x,z)
	x = -dx
	z = 0.
	call vpumove(x,z)
	x = -0.5*dx
	z = dz
	call vpudraw(x,z)
	x = 0.5*dx
	z = dz
	call vpudraw(x,z)
	x = dx
	z = 0.
	call vpudraw(x,z)
	x = 0.5*dx
	z = -dz
	call vpudraw(x,z)
	x = -0.5*dx
	z = -dz
	call vpudraw(x,z)
	x = -dx
	z = 0.
	call vpudraw(x,z)
	call vpdash(0.,0.,0.,0.)
	call vpcolor(6)
	fat = 4.*plotfat
	call vpfat(fat)
	x = 0.
	z = 0.
	call vpumove(x,z)
	x = -dx
	z = 0.
	call vpudraw(x,z)
	x = -0.5*dx
	z = -dz
	call vpudraw(x,z)
	x = 0.
	z = 0.
	call vpudraw(x,z)
	
	call vpcolor(3)
	fat = 2*plotfat
	call vpfat(fat)
	call vpumove(xb,zb)
	if(outtype == 0)
	{
	   xs = xmin
	   zs = zmin-0.5*dz
	}
	else
	{
	   xs = xmin
	   zs = zmin-2.5*dz
	}
	x1b = (-zs*xb+xs*zb)*(zb-zs)/((xb-xs)**2+(zb-zs)**2)
	z1b = -(-zs*xb+xs*zb)*(xb-xs)/((xb-xs)**2+(zb-zs)**2)
	call vpudraw(x1b,z1b)
	rr = sqrt((x1b-xs)**2+(z1b-zs)**2)
	if(outtype == 0)
	{
	   theta1 = atan((x1b-xs)/(z1b-zs))-4.*atan(1.)/18.
	   theta2 = atan((x1b-xs)/(z1b-zs))+4.*atan(1.)/18.
	   x0 = xs
	   z0 = zs
	}
	else
	{
	   theta1 = 4.*atan(1.)+atan((x1b-xs)/(z1b-zs))-4.*atan(1.)/18.
	   theta2 = 4.*atan(1.)+atan((x1b-xs)/(z1b-zs))+4.*atan(1.)/18.
	   x0 = xs
	   z0 = zs
	}
	if(outtype == 0)
	{
	x = x0+rr*sin(theta1)
	z = z0+rr*cos(theta1)
	call vpumove(x,z)
	do iarray = 2,narray
	{
	   theta = theta1+(iarray-1)*(theta2-theta1)/(narray-1)
	   x = x0+rr*sin(theta)
	   z = z0+rr*cos(theta)
	   call vpudraw(x,z)
	}
	}
	call vpdash(0.1,0.1,0.1,0.1)
	call vpcolor(7)
	fat = plotfat
	call vpfat(fat)
	call vpumove(x1b,z1b)
	call vpudraw(0.,0.)
	call vpdash(0.,0.,0.,0.)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	if(outtype == 0)
	{
	   x2 = x1b+0.1*zxrange*(xb-xs)/sqrt((xb-xs)**2+(zb-zs)**2)
	   z2 = z1b+0.1*zxrange*(zb-zs)/sqrt((xb-xs)**2+(zb-zs)**2)
	}
	else
	{
	   x2 = x1b+0.1*zxrange*(xb-xs)/sqrt((xb-xs)**2+(zb-zs)**2)
	   z2 = z1b+0.1*zxrange*(zb-zs)/sqrt((xb-xs)**2+(zb-zs)**2)
	}
	call vpuarrow(x1b,z1b,x2,z2,0.02*zxrange)

	call vpcolor(3)
	fat = 2*plotfat
	call vpfat(fat)
	call vpumove(xa,za)
	if(outtype == 0)
	{
	   xs = -2.*dx
	   zs = 0.5*dz
	}
	else
	{
	   xs = -2.*dx
	   zs = -0.5*dz
	}
	rr = sqrt(xs*xs+zs*zs)
	x1a = (-zs*xa+xs*za)*(za-zs)/((xa-xs)**2+(za-zs)**2)
	z1a = -(-zs*xa+xs*za)*(xa-xs)/((xa-xs)**2+(za-zs)**2)
	call vpudraw(x1a,z1a)
	rr = sqrt((x1a-xs)**2+(z1a-zs)**2)
	if(outtype == 0)
	{
	   theta1 = atan((x1a-xs)/(z1a-zs))-4.*atan(1.)/18.
	   theta2 = atan((x1a-xs)/(z1a-zs))+4.*atan(1.)/18.
	   x0 = xs
	   z0 = zs
	}
	else
	{
	   theta1 = atan((x1a-xs)/(z1a-zs))-4.*atan(1.)/18.
	   theta2 = atan((x1a-xs)/(z1a-zs))+4.*atan(1.)/18.
	   x0 = xs
	   z0 = zs
	}
	if(outtype == 1)
	{
	x = x0+rr*sin(theta1)
	z = z0+rr*cos(theta1)
	call vpumove(x,z)
	do iarray = 2,narray
	{
	   theta = theta1+(iarray-1)*(theta2-theta1)/(narray-1)
	   x = x0+rr*sin(theta)
	   z = z0+rr*cos(theta)
	   call vpudraw(x,z)
	}
	}
	call vpdash(0.1,0.1,0.1,0.1)
	call vpcolor(7)
	fat = plotfat
	call vpfat(fat)
	call vpumove(x1a,z1a)
	call vpudraw(0.,0.)
	call vpdash(0.,0.,0.,0.)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	if(outtype == 0)
	{
	   x2 = x1a+0.1*zxrange*(xa-xs)/sqrt((xa-xs)**2+(za-zs)**2)
	   z2 = z1a+0.1*zxrange*(za-zs)/sqrt((xa-xs)**2+(za-zs)**2)
	}
	else
	{
	   x2 = x1a+0.1*zxrange*(xa-xs)/sqrt((xa-xs)**2+(za-zs)**2)
	   z2 = z1a+0.1*zxrange*(za-zs)/sqrt((xa-xs)**2+(za-zs)**2)
	}
	call vpuarrow(x1a,z1a,x2,z2,0.02*zxrange)

# draw nodes
	x = xa
	z = za
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.01*zxrange*sin(theta)
	   zz(iarray) = z+0.01*zxrange*cos(theta)
	}
	call vpcolor(7)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
	x = xb
	z = zb
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.01*zxrange*sin(theta)
	   zz(iarray) = z+0.01*zxrange*cos(theta)
	}
	call vpcolor(7)
	call vpufill(xx,zz,narray)
	call vpcolor(5)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)
#	x = xc
#	z = zc
#	do iarray = 1,narray
#	{
#	   theta = (iarray-1)*8*atan(1.)/(narray-1)
#	   xx(iarray) = x+0.01*zxrange*sin(theta)
#	   zz(iarray) = z+0.01*zxrange*cos(theta)
#	}
#	call vpcolor(7)
#	call vpufill(xx,zz,narray)
#	call vpcolor(5)
#	fat = 4*plotfat
#	call vpfat(fat)
#	call vpupline(xx,zz,narray)
	x = 0.
	z = 0.
	do iarray = 1,narray
	{
	   theta = (iarray-1)*8*atan(1.)/(narray-1)
	   xx(iarray) = x+0.01*zxrange*sin(theta)
	   zz(iarray) = z+0.01*zxrange*cos(theta)
	}
	call vpcolor(0)
	call vpufill(xx,zz,narray)
	call vpcolor(3)
	fat = 4*plotfat
	call vpfat(fat)
	call vpupline(xx,zz,narray)

# write title
        call vpcolor(7)
        call vpfat(titlefat)
        call vptjust(2,1)
        x = xcenter
        z = zmin-0.008*titlesz*zxrange
        call vputext(x,z,titlesz,0,title)

	call vpcolor(7)
        call vpfat(4)
        call vptjust(2,3)
        x = xa-0.04*zxrange
        z = za
        call vputext(x,z,10,0,'a')
        x = xb-0.03*zxrange
        z = zb-0.03*zxrange
        call vputext(x,z,10,0,'b')
#        x = xc+0.03*zxrange
#        z = zc-0.03*zxrange
#        call vputext(x,z,10,0,'c')
        x = 0.04*zxrange
        z = 0.025*zxrange
        call vputext(x,z,10,0,'o')
	if(outtype == 0)
	{
           x = x1b+0.04*zxrange
           z = z1b+0.00*zxrange
           call vputext(x,z,10,0,'b\\^\\s60 \\F15 I\\^')
           x = x1a
           z = z1a-0.04*zxrange
           call vputext(x,z,10,0,'a\\^\\s60 \\F15 I\\^')
	}
	else
	{
           x = x1b-0.04*zxrange
           z = z1b+0.02*zxrange
           call vputext(x,z,10,0,'b\\^\\s60 \\F15 I\\^')
           x = x1a+0.02*zxrange
           z = z1a+0.04*zxrange
           call vputext(x,z,10,0,'a\\^\\s60 \\F15 I\\^')
	}
#        call vptjust(2,3)
#        x = -0.169534-0.04*zxrange
#        z = 0.0413062
#        call vputext(x,z,10,0,'q\\s60 \\_a\\^')
#	call vptfont(-1,-1,2)
#        x = 0.0804338+0.015*zxrange
#        z = -0.0862325-0.04*zxrange
#        call vputext(x,z,10,0,'q\\s60 \\_c\\^')
#        call vptjust(3,5)
#        x = -0.193844-0.024*zxrange
#        z = 0.455585+0.01*zxrange
#        call vputext(x,z,10,0,'a\\^\\s60 \\F15 I\\^')
   
# draw a frame
	if(wantframe != 0.)
	{
	   call vpcolor(7)
	   call vpfat(1)
	   call vpumove(xmin,zmin)
	   call vpudraw(xmin,zmax)
	   call vpudraw(xmax,zmax)
	   call vpudraw(xmax,zmin)
	   call vpudraw(xmin,zmin)
	}

stop 
end
